## sks 1.1.0

=== Makefile ===
#
#   This file is part of SKS.  SKS is free software; you can
#   redistribute it and/or modify it under the terms of the GNU General
#   Public License as published by the Free Software Foundation; either
#   version 2 of the License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful, but
#   WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA 
#
CINCLUDES=-I`ocamlc -where`
CC=gcc
CXX=g++
CFLAGS=-O3 -Werror-implicit-function-declaration $(CINCLUDES) -I .
CXXFLAGS=-O3 $(CINCLUDES) -I .

ifndef OCAMLC
	OCAMLC=ocamlc
endif
ifndef OCAMLOPT
	OCAMLOPT=ocamlopt
endif
ifndef CAMLP4O
	CAMLP4O=camlp4o
endif

export OCAMLC
export OCAMLOPT
export CAMLP4O

include Makefile.local

ifndef PREFIX
	PREFIX=/usr/local
endif
ifeq ($(BDBLIB),) 
	OCAMLLIB=
else 
	OCAMLLIB= -ccopt $(BDBLIB)
endif

CAMLP4=-pp $(CAMLP4O)
CAMLINCLUDE= -I lib -I bdb
COMMONCAMLFLAGS=$(CAMLINCLUDE) $(OCAMLLIB) -ccopt -Lbdb -dtypes -ccopt -pthread
OCAMLDEP=ocamldep $(CAMLP4) 
CAMLLIBS=unix.cma str.cma bdb.cma nums.cma bigarray.cma cryptokit.cma
OCAMLFLAGS=$(COMMONCAMLFLAGS) -g $(CAMLLIBS)
OCAMLOPTFLAGS=$(COMMONCAMLFLAGS) -inline 40 $(CAMLLIBS:.cma=.cmxa) 

EXE=sks sks_add_mail
ALL=$(EXE)
ALL.bc=$(EXE:=.bc)

all: $(ALL) 
all.bc: $(ALL.bc) 

COBJS=crc.o

MOBJS.bc= pSet.cmo pMap.cmo utils.cmo heap.cmo mList.cmo \
       mTimer.cmo mArray.cmo

MOBJS=$(MOBJS.bc:.cmo=.cmx)

ROBJS.bc= settings.cmo pstyle.cmo getfileopts.cmo \
	common.cmo channel.cmo eventloop.cmo ehandlers.cmo \
	bitstring.cmo meteredChannel.cmo \
	number.cmo prime.cmo zZp.cmo rMisc.cmo \
	linearAlg.cmo poly.cmo decode.cmo \
	fqueue.cmo prefixTree.cmo msgContainer.cmo \
	nbMsgContainer.cmo cMarshal.cmo reconMessages.cmo \
	server.cmo client.cmo reconCS.cmo \
	number_test.cmo decode_test.cmo poly_test.cmo
ROBJS=$(ROBJS.bc:.cmo=.cmx)

OBJS.bc=packet.cmo parsePGP.cmo sStream.cmo bdbwrap.cmo \
	key.cmo keyHash.cmo keyMerge.cmo fixkey.cmo \
	fingerprint.cmo keydb.cmo armor.cmo \
	dbMessages.cmo htmlTemplates.cmo wserver.cmo \
	membership.cmo tester.cmo request.cmo \
	stats.cmo index.cmo mRindex.cmo pTreeDB.cmo \
	sendmail.cmo recvmail.cmo mailsync.cmo \
	clean_keydb.cmo build.cmo fastbuild.cmo pbuild.cmo merge_keyfiles.cmo \
	sksdump.cmo incdump.cmo dbserver.cmo reconComm.cmo recoverList.cmo \
	catchup.cmo reconserver.cmo update_subkeys.cmo sks_do.cmo unit_tests.cmo

OBJS=$(OBJS.bc:.cmo=.cmx)

RSERVOBJS.bc=reconComm.cmo recoverList.cmo catchup.cmo reconserver.cmo
RSERVOBJS=$(RSERVOBJS.bc:.cmo=.cmx)

ALLOBJS.bc=$(COBJS) $(MOBJS.bc) $(ROBJS.bc) $(OBJS.bc)
ALLOBJS=$(ALLOBJS.bc:.cmo=.cmx)

EXEOBJS.bc=$(RSERVOBJS.bc) build.cmo fastbuild.cmo dbserver.cmo pdiskTest.cmo

LIBS.bc= lib/cryptokit.cma bdb/bdb.cma
LIBS=$(LIBS.bc:.cma=.cmxa)

VERSION := $(shell cat VERSION)
VERSIONPREFIX = sks-$(VERSION)
COMMA_VERSION := $(shell cat VERSION | sed y/./,/)
FILES := $(shell sed s/.*/$(VERSIONPREFIX)\\/\&/ FILES)

# Special case make rules for functions which require preprocessor directives

common.cmx: common.ml VERSION
	$(OCAMLOPT) $(OCAMLOPTFLAGS) \
	-pp "sed s/__VERSION__/$(COMMA_VERSION)/" -c $<

common.cmo: common.ml VERSION
	$(OCAMLC) $(OCAMLFLAGS) -pp "sed s/__VERSION__/$(COMMA_VERSION)/" -c $<

keyMerge.cmo: keyMerge.ml
	$(OCAMLC) $(OCAMLFLAGS) $(CAMLP4) -c $<

keyMerge.cmx: keyMerge.ml
	$(OCAMLOPT) $(OCAMLOPTFLAGS) $(CAMLP4) -c $<

# Special targets 

install: 
	mkdir -p $(PREFIX)/bin
	install sks_build.sh sks sks_add_mail $(PREFIX)/bin
	mkdir -p $(MANDIR)/man8
	install sks.8.gz $(MANDIR)/man8

install.bc: 
	mkdir -p $(PREFIX)/bin
	install sks_build.bc.sh sks.bc sks_add_mail.bc $(PREFIX)/bin
	mkdir -p $(MANDIR)/man8
	install sks.8.gz $(MANDIR)/man8


Makefile.local:
	touch Makefile.local

src: 
	if [ ! -x $(VERSIONPREFIX) ]; then ln -s . $(VERSIONPREFIX); fi
	tar cfz $(VERSIONPREFIX).tgz $(FILES)
	rm $(VERSIONPREFIX)

# Ordinary targets

sks.8.gz: sks.8
	gzip -f sks.8

sks.8: sks.pod
	pod2man -c "SKS OpenPGP Key server" --section 8 -r 0.1 -name sks sks.pod sks.8

sks: $(LIBS) $(ALLOBJS) sks.cmx
	$(OCAMLOPT) -o sks $(OCAMLOPTFLAGS) $(ALLOBJS) sks.cmx

sks.bc: $(LIBS.bc) $(ALLOBJS.bc) sks.cmo
	$(OCAMLC) -o sks.bc $(OCAMLFLAGS) $(ALLOBJS.bc) sks.cmo

nbtest.bc: $(LIBS.bc) $(ALLOBJS.bc) nbtest.cmo 
	$(OCAMLC) -o nbtest.bc $(OCAMLFLAGS) $(ALLOBJS.bc) nbtest.cmo 

ptest: $(LIBS) $(ALLOBJS) ptest.cmx
	$(OCAMLOPT) -o ptest $(OCAMLOPTFLAGS) $(ALLOBJS) \
	ptest.cmx

ptree_consistency_test: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx \
		ptree_consistency_test.cmx
	$(OCAMLOPT) -o ptree_consistency_test $(OCAMLOPTFLAGS) $(ALLOBJS) \
	reconPTreeDb.cmx ptree_consistency_test.cmx

ptree_consistency_test.bc: $(LIBS.bc) $(ALLOBJS.bc) reconPTreeDb.cmo \
		ptree_consistency_test.cmo
	$(OCAMLC) -o ptree_consistency_test.bc $(OCAMLFLAGS) $(ALLOBJS.bc) \
	reconPTreeDb.cmo ptree_consistency_test.cmo

ptree_db_test: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx \
		ptree_db_test.cmx
	$(OCAMLOPT) -o ptree_db_test $(OCAMLOPTFLAGS) $(ALLOBJS) \
	reconPTreeDb.cmx ptree_db_test.cmx

ptree_db_test.bc: $(LIBS.bc) $(ALLOBJS.bc) reconPTreeDb.cmo \
		ptree_db_test.cmo
	$(OCAMLC) -o ptree_db_test.bc $(OCAMLFLAGS) $(ALLOBJS.bc) \
	reconPTreeDb.cmo ptree_db_test.cmo

sks_do.bc: $(LIBS.bc) $(ALLOBJS.bc) sks_do.cmo
	$(OCAMLC) -o sks_do.bc $(OCAMLFLAGS) $(ALLOBJS.bc) sks_do.cmo

sks_do: $(LIBS) $(ALLOBJS) sks_do.cmx
	$(OCAMLOPT) -o sks_do $(OCAMLOPTFLAGS) $(ALLOBJS) sks_do.cmx


sks_add_mail.bc: pMap.cmo pSet.cmo add_mail.cmo
	$(OCAMLC) -o sks_add_mail.bc -g unix.cma \
	pMap.cmo pSet.cmo add_mail.cmo

sks_add_mail: $(LIBS) pMap.cmx pSet.cmx add_mail.cmx
	$(OCAMLOPT) -o sks_add_mail unix.cmxa \
	pMap.cmx pSet.cmx add_mail.cmx

ocamldoc.out: $(ALLOBJS) $(EXEOBJS)
	ocamldoc -hide Pervasives,UnixLabels,MoreLabels \
	-dot $(CAMLP4O) -d doc -I lib -I bdb *.ml *.mli

sks_logdump.bc: $(LIBS.bc) $(ALLOBJS.bc) logdump.cmo
	$(OCAMLC) -o sks_logdump.bc $(OCAMLFLAGS) $(ALLOBJS.bc) logdump.cmo

sks_logdump: $(LIBS) $(ALLOBJS) logdump.cmx
	$(OCAMLOPT) -o sks_logdump $(OCAMLOPTFLAGS) $(ALLOBJS) \
	logdump.cmx

bugscript: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx bugscript.cmx 
	$(OCAMLOPT) -o bugscript $(OCAMLOPTFLAGS) $(ALLOBJS) \
	reconPTreeDb.cmx bugscript.cmx

bugscript.bc: $(LIBS.bc) $(ALLOBJS.bc) reconPTreeDb.cmo bugscript.cmo
	$(OCAMLC) -o bugscript.bc $(OCAMLFLAGS) $(ALLOBJS.bc) \
	reconPTreeDb.cmo bugscript.cmo

ptree_replay: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx ptree_replay.cmx 
	$(OCAMLOPT) -o ptree_replay $(OCAMLOPTFLAGS) $(ALLOBJS) \
	reconPTreeDb.cmx ptree_replay.cmx

modules.dot: ocamldoc.out
	./recolor.py < ocamldoc.out > modules.dot

modules.ps: modules.dot
	dot -Nfontsize=200 modules.dot -Tps -o modules.ps

doc: $(ALLOBJS) $(EXEOBJS)
	mkdir -p doc
	ocamldoc -hide Pervasives,UnixLabels,MoreLabels \
	-html $(CAMLP4O) -d doc -I lib -I bdb *.ml *.mli

dist:
	cd .. && \
	tar cvfz sks.tgz \
	sks/*.ml sks/*.mli sks/*.c sks/Makefile \
	sks/.depend sks/*.tar.gz \
	sks/bdb/Makefile sks/bdb/*.ml sks/bdb/*.mli sks/bdb/*.c \
	sks/bdb/*.h sks/README sks/COPYING sks/VERSION sks/FILES \
	sks/Makefile.local.unused sks/sks.8

##################################
# LIBS
##################################

bdb/bdb.cmxa: bdb/bdb_stubs.c bdb/bdb_stubs.h
	cd bdb && $(MAKE) bdb.cmxa

bdb/bdb.cma: bdb/bdb_stubs.c bdb/bdb_stubs.h
	cd bdb && $(MAKE) bdb.cma

bdbclean:
	cd bdb && $(MAKE) clean

##################################


prepared:
	mkdir -p lib
	mkdir -p tmp/bin
	mkdir -p tmp/include
	touch prepared


CKDIR=cryptokit-1.0

$(CKDIR)/README: 
	tar xmvfz $(CKDIR).tar.gz

$(CKDIR)/cryptokit.cma: $(CKDIR)/README
	cd $(CKDIR) && $(MAKE) all

$(CKDIR)/cryptokit.cmxa: $(CKDIR)/README
	cd $(CKDIR) && $(MAKE) allopt

lib/cryptokit.cma: $(CKDIR)/cryptokit.cma $(CKDIR)/cryptokit.cmxa prepared
	cp $(CKDIR)/cryptokit.cmi $(CKDIR)/cryptokit.cma \
	   $(CKDIR)/cryptokit.mli lib
	cp $(CKDIR)/libcryptokit.a lib
	if test -f $(CKDIR)/dllcryptokit.so; then \
	   cp $(CKDIR)/dllcryptokit.so lib; fi
	if test -f $(CKDIR)/cryptokit.cmxa; then \
	   cp $(CKDIR)/cryptokit.cmxa $(CKDIR)/cryptokit.cmx \
	   $(CKDIR)/cryptokit.a lib; fi

lib/cryptokit.cmxa: lib/cryptokit.cma

################################
# old stuff
################################
prefix_test: $(ALLOBJS) prefix_test.cmx
	$(OCAMLOPT) -o prefix_test $(OCAMLOPTFLAGS) $(ALLOBJS) prefix_test.cmx

prefix_test.opt: $(ROBJS.opt) prefix_test.cmx
	$(OCAMLOPT) -o prefix_test.opt $(OCAMLOPTFLAGS) $(ROBJS.opt) \
	prefix_test.cmx

pdiskTest: $(LIBS) $(MOBJS) $(ROBJS) pdiskTest.cmo
	$(OCAMLC) -o pdiskTest $(OCAMLFLAGS) $(MOBJS) $(ROBJS) pdiskTest.cmo

pdiskTest.opt: $(LIBS.opt) $(MOBJS.opt) $(ROBJS.opt) pdiskTest.cmx
	$(OCAMLOPT) -o pdiskTest.opt $(OCAMLOPTFLAGS) \
	$(MOBJS.opt) $(ROBJS.opt) pdiskTest.cmx

pdtcaml: $(LIBS) $(ROBJS) pdiskTest.cmo
	ocamlmktop -o pdtcaml -custom $(CAMLLIBS) $(CAMLINCLUDE) \
	$(ROBJS) pdiskTest.cmo

script: $(LIBS) $(ALLOBJS) script.cmo
	$(OCAMLC) -o script $(OCAMLFLAGS) $(ALLOBJS) script.cmo 

dbtest.bc: $(LIBS.bc) $(ALLOBJS.bc) dbtest.cmo
	$(OCAMLC) -o dbtest.bc $(OCAMLFLAGS) $(ALLOBJS.bc) dbtest.cmo 

dbtest: $(LIBS) $(ALLOBJS) dbtest.cmx
	$(OCAMLOPT) -o dbtest $(OCAMLOPTFLAGS) $(ALLOBJS) dbtest.cmx

tester: $(LIBS) $(ALLOBJS) tester.cmo
	$(OCAMLC) -o tester $(OCAMLFLAGS) $(ALLOBJS) tester.cmo 

dumbloop: $(LIBS) $(ALLOBJS) dumbloop.cmo
	$(OCAMLC) -o dumbloop $(OCAMLFLAGS) $(ALLOBJS) dumbloop.cmo

scan: $(OBJS) cryptokit dblib scan.ml
	$(OCAMLC) -o scan $(OCAMLFLAGS) $(OBJS) scan.ml

query: $(LIBS) $(ALLOBJS) query.cmo
	$(OCAMLC) -o query $(OCAMLFLAGS) $(ALLOBJS) query.cmo

printids: $(OBJS:.cmo=.cmx) cryptokit printids.ml
	$(OCAMLOPT) -o printids $(OCAMLOPTFLAGS) $(OBJS:.cmo=.cmx) printids.ml

printids.bc: $(OBJS) cryptokit printids.ml
	$(OCAMLC) -o printids $(OCAMLFLAGS) $(OBJS) printids.ml

krecode: $(ALLOBJS.opt) $(LIBS) recode.ml
	$(OCAMLOPT) -o krecode $(OCAMLOPTFLAGS) $(ALLOBJS.opt) recode.ml

rcaml: $(LIBS.bc) $(ALLOBJS.bc) 
	ocamlmktop -o rcaml -custom $(CAMLLIBS) $(CAMLINCLUDE) \
	$(ALLOBJS.bc) $(OCAMLLIB)



# Common rules
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.o:
	$(OCAMLOPT) -output-obj $(OCAMLOPTFLAGS) $< 

.cpp.o:
	$(CXX) $(CXXFLAGS) -c $<

.c.o:
	$(CC) $(CFLAGS) -c $< 

.c.obj:
	$(CC) $(CFLAGS) /c $< 

.ml.cmo:
	$(OCAMLC) $(OCAMLFLAGS) -c $<

.mli.cmi:
	$(OCAMLC) $(OCAMLFLAGS) -c $<

.ml.cmx:
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c $<


# Clean up
mlclean:
	rm -f *.cm[iox]
	rm -f *.annot
	rm -f *.opt
	rm -f *.bc
	rm -f $(ALL) $(ALL.bc)

clean: mlclean
	rm -f *.o
	rm -f prepared

cleanall: clean bdbclean
	rm -f lib/*
	rm -rf $(CKDIR)
	rm -rf $(NXDIR)
	rm -rf

# Dependencies
dep: 
	$(OCAMLDEP) $(INCLUDES) *.ml *.mli > .depend

include .depend


# DO NOT DELETE

=== bdb/Makefile ===
#########################################################################
#                                                                       #
#                            Objective Caml                             #
#                                                                       #
#            Xavier Leroy, projet Cristal, INRIA Rocquencourt           #
#                                                                       #
#   Copyright 1999 Institut National de Recherche en Informatique et    #
#   en Automatique.  All rights reserved.  This file is distributed     #
#   under the terms of the GNU Library General Public License, with     #
#   the special exception on linking described in file ../../LICENSE.   #
#                                                                       #
#########################################################################

# $Id: Makefile,v 1.6 2003/07/05 15:16:29 yminsky Exp $

CINCLUDES=-I`ocamlc -where` $(BDBINCLUDE)
CC=gcc
CXX=g++
CFLAGS=-O3 -Werror-implicit-function-declaration $(CINCLUDES) $(BDBLIB) -I .
CXXFLAGS=-O3 $(CINCLUDES) $(BDBLIB) -I .

MKLIB=ocamlmklib
RANLIB=ranlib
OCAMLDEP=ocamldep $(PP)
CAMLINCLUDE=
COMMONCAMLFLAGS= $(CAMLINCLUDE) $(PP) #-thread 
CAMLLIBS=unix.cma str.cma mylibs.cma 
OCAMLFLAGS=$(COMMONCAMLFLAGS) -g 
OCAMLOPTFLAGS=$(COMMONCAMLFLAGS) -inline 40 

ifndef LIBDB
LIBDB=-ldb-4.6
endif

COBJS = bdb_stubs.o

ocextr: ocextr.ml
	$(OCAMLOPT) -o ocextr ocextr.ml

libbdb.a: $(COBJS)
	$(MKLIB) -custom -o bdb $(COBJS)

bdb_stubs.o: bdb_stubs.h bdb_stubs.c

bdb.ml: ocextr bdb_stubs.c
	./ocextr bdb_stubs.c > bdb.ml

bdb.cma: bdb.cmo libbdb.a
	$(MKLIB) -custom -o bdb bdb.cmo -lbdb $(LIBDB)

bdb.cmxa: bdb.cmx libbdb.a
	$(MKLIB) -custom -o bdb bdb.cmx -lbdb $(LIBDB)

bdbcaml: bdb.cma
	ocamlmktop -o bdbcaml -custom unix.cma bdb.cma $^

partialclean:
	rm -f *.cm*

clean: partialclean
	rm -f *.a *.o

install:
	cp libmldb.a $(LIBDIR)/libmldb.a
	cd $(LIBDIR); $(RANLIB) libmldb.a
	cp db.cma db.cmi db.mli $(LIBDIR)

installopt:
	cp db.cmx db.cmxa db.a $(LIBDIR)
	cd $(LIBDIR); $(RANLIB) db.a



# Common rules
.SUFFIXES: .ml .mli .cmo .cmi .cmx

.ml.o:
	$(OCAMLOPT) -output-obj $(OCAMLOPTFLAGS) $< 

.cpp.o:
	$(CXX) $(CXXFLAGS) -c $<

.c.o:
	$(CC) $(CFLAGS) -c $< 

.c.obj:
	$(CC) $(CFLAGS) /c $< 

.ml.cmo:
	$(OCAMLC) $(OCAMLFLAGS) -c $<

.mli.cmi:
	$(OCAMLC) $(OCAMLFLAGS) -c $<

.ml.cmx:
	$(OCAMLOPT) $(OCAMLOPTFLAGS) -c $<

# Dependencies
#dep:
#	$(OCAMLDEP) $(INCLUDES) *.ml *.mli > .depend

#include .depend


# DO NOT DELETE

## sks 1.1.1

=== Makefile ===
--- 
+++ 
@@ -47,15 +47,15 @@
 
 CAMLP4=-pp $(CAMLP4O)
 CAMLINCLUDE= -I lib -I bdb
-COMMONCAMLFLAGS=$(CAMLINCLUDE) $(OCAMLLIB) -ccopt -Lbdb -dtypes -ccopt -pthread
+COMMONCAMLFLAGS=$(CAMLINCLUDE) $(OCAMLLIB) -ccopt -Lbdb -dtypes -ccopt -pthread -warn-error A
 OCAMLDEP=ocamldep $(CAMLP4) 
 CAMLLIBS=unix.cma str.cma bdb.cma nums.cma bigarray.cma cryptokit.cma
 OCAMLFLAGS=$(COMMONCAMLFLAGS) -g $(CAMLLIBS)
 OCAMLOPTFLAGS=$(COMMONCAMLFLAGS) -inline 40 $(CAMLLIBS:.cma=.cmxa) 
 
 EXE=sks sks_add_mail
-ALL=$(EXE)
-ALL.bc=$(EXE:=.bc)
+ALL=$(EXE) sks.8.gz
+ALL.bc=$(EXE:=.bc) sks.8.gz
 
 all: $(ALL) 
 all.bc: $(ALL.bc) 
@@ -153,6 +153,12 @@
 sks.8: sks.pod
 	pod2man -c "SKS OpenPGP Key server" --section 8 -r 0.1 -name sks sks.pod sks.8
 
+spider: $(LIBS) $(ALLOBJS) spider.cmx
+	$(OCAMLOPT) -o spider $(OCAMLOPTFLAGS) $(ALLOBJS) spider.cmx
+
+spider.bc: $(LIBS.bc) $(ALLOBJS.bc) spider.cmo
+	$(OCAMLC) -o spider.bc $(OCAMLFLAGS) $(ALLOBJS.bc) spider.cmo
+
 sks: $(LIBS) $(ALLOBJS) sks.cmx
 	$(OCAMLOPT) -o sks $(OCAMLOPTFLAGS) $(ALLOBJS) sks.cmx
 
@@ -242,7 +248,7 @@
 	sks/.depend sks/*.tar.gz \
 	sks/bdb/Makefile sks/bdb/*.ml sks/bdb/*.mli sks/bdb/*.c \
 	sks/bdb/*.h sks/README sks/COPYING sks/VERSION sks/FILES \
-	sks/Makefile.local.unused sks/sks.8
+	sks/Makefile.local.unused sks/sks.8.gz
 
 ##################################
 # LIBS
@@ -383,6 +389,7 @@
 clean: mlclean
 	rm -f *.o
 	rm -f prepared
+	rm -f sks.8.gz
 
 cleanall: clean bdbclean
 	rm -f lib/*

## sks 1.1.1+dpkgv3

=== debian/changelog ===
sks (1.1.1+dpkgv3-7ubuntu0.2) precise-proposed; urgency=low

  * Look for ^.i not ^ii in libdbX.Y-dev packages for BDB_VERSION. And assert
    that we have a value (LP: #1021650)

 -- Stefano Rivera <stefanor@ubuntu.com>  Fri, 06 Jul 2012 22:43:42 +0200

sks (1.1.1+dpkgv3-7ubuntu0.1) precise-proposed; urgency=low

  * Provide OLD_BDB versions for Ubuntu, so that Berkeley DB upgrades will
    be performed on the right upgrades (LP: #1020034)
  * Create /var/lib/sks/berkeley_db.active even when we aren't upgrading BDB
    versions, so that we'll rely less on heuristics in the future.

 -- Stefano Rivera <stefanor@ubuntu.com>  Mon, 02 Jul 2012 15:10:31 +0200

sks (1.1.1+dpkgv3-7) unstable; urgency=low

  * remove default mailsync entry to prevent sks from sending email syncs
    per default (Thanks to Graham Dunn <grdunn@rim.com> for the hint)
  * fix sks.daily to not depend on db4.7 (closes: #627767)
  * fix sks.postinst to only upgrade the db if the version changes

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Tue, 31 May 2011 17:05:32 +0200

sks (1.1.1+dpkgv3-6.2) unstable; urgency=low

  * Non-maintainer upload.
  * Handle gracefully missing db directory, which can happen if:
    + sks was not enabled and didn't create PTree directory
    + keys haven't been imported to the package
  * Update instructions for retrieving keydump (Closes: #605454)
  * Install README from source directory (Closes: #599868)
  * Use dh_ocaml >= 0.9 (Closes: #599579)
  * Add hints to run commands as debian-sks user as suggested in the BTS

 -- Ondřej Surý <ondrej@debian.org>  Thu, 19 May 2011 11:56:33 +0200

sks (1.1.1+dpkgv3-6.1) unstable; urgency=low

  * Non-maintainer upload.
  * Remove XA environment usage (patch from upstream) and use generic -ldb
    library to link with (Closes: #621384)
  * Add automagick upgrade of Berkeley DB databases (Closes: #606183)
  * Change db4.7-util to Recommends: db4.7-util and Depends: db-util

 -- Ondřej Surý <ondrej@debian.org>  Fri, 13 May 2011 12:33:13 +0200

sks (1.1.1+dpkgv3-6) unstable; urgency=high

  * fix to not really working fix for strip of bytecode (closes: 599029)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Mon, 25 Oct 2010 18:11:37 +0200

sks (1.1.1+dpkgv3-5) unstable; urgency=high

  * add nostrip to DEB_BUILD_OPTIONS on architectures with ocaml
    bytecode. (closes: 599029)
  * don't depend on mta etc., as mailsync is now mostly obsolete (closes:
    599280)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Thu, 07 Oct 2010 20:49:13 +0200

sks (1.1.1+dpkgv3-4) unstable; urgency=low

  * remove pramberger.at from README.Debian, because it is no longer
    availlable (closes: #597818)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Mon, 27 Sep 2010 12:09:03 +0200

sks (1.1.1+dpkgv3-3) unstable; urgency=low

  * fix typo in control to include correct ocaml-base-nox dependency
    (closes: #596563)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Sun, 12 Sep 2010 21:14:26 +0200

sks (1.1.1+dpkgv3-2) unstable; urgency=low

  * fix build and install to work on plattforms which don't have the
    native ocaml compile (closes: #594557)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Fri, 27 Aug 2010 12:09:33 +0200

sks (1.1.1+dpkgv3-1) unstable; urgency=high

  * include NEWS file to inform about db update (closes: #594103)
  * fix README.Debian to include a working download URL for a fresh
    keydump (closes: 593852)
  * 511_gcc4.4_prototypes: Don't redefine bzero(3), fixes FTBFS (Thanks to
    Daniel T Chen <crimsun@ubuntu.com>)
  * convert to source format 3 with quilt patches (closes: #576057)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Wed, 25 Aug 2010 18:11:26 +0200

sks (1.1.1-2) unstable; urgency=low

  * don't chown PIDDIR in postinst, since we do it in init (Closes: #566922)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Mon, 08 Feb 2010 15:00:34 +0100

sks (1.1.1-1) unstable; urgency=low

  * New upstream
  * fix watchfile
  * fix some lintian errors/warnings

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Sat, 28 Nov 2009 15:38:39 +0100

sks (1.1.0-9) unstable; urgency=low

  * Explicitly require libdb4.7, 4.8 is not supported (Closes: #549798).

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Wed, 04 Nov 2009 21:40:36 +0100

sks (1.1.0-8) unstable; urgency=low

  * Teach dbserver about content-type for .html.
  * Allow - in filenames for webserver.
  * closes: #505014
  * thanks to Peter Palfrader <weasel@debian.org>

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Thu, 16 Jul 2009 23:33:21 +0200

sks (1.1.0-7) unstable; urgency=low

  * fix patch for PIDDIR
  * link against libdb4.7
  * really include watch file

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Thu, 16 Jul 2009 00:22:06 +0200

sks (1.1.0-6) unstable; urgency=low

  * remove Peter Palfrader from Maintainer and Uploaders
  * add watch file
  * Remove reference to native-arch in old OCaml standard library path
    (Thanks to Stephane Glondu <steph@glondu.net>) (Closes: #535267)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Fri, 10 Jul 2009 23:34:36 +0200

sks (1.1.0-5) unstable; urgency=low

  * Check spool directories for existance (Thanks to Filippo Giunchedi
    <filippo@debian.org>) (Closes: #493335)
  * make PIDDIR on startup to workaround /var/run on a tempfs

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Thu, 18 Jun 2009 16:39:09 +0200

sks (1.1.0-4) unstable; urgency=low

  * fix cron.daily to call correct db*_archive and print unwanted messages
    (closes #491281)
  * fix comment in README.Debian about correcting permissions after
    initial database build

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Tue, 22 Jul 2008 17:27:58 +0200

sks (1.1.0-3) unstable; urgency=low

  * make separate patches for manpage install for upstream
  * patch to correctly build bdb on non native ocaml archs



=== debian/control ===
Source: sks
Section: net
Priority: optional
Standards-Version: 3.8.3
Maintainer: Christoph Martin <christoph.martin@uni-mainz.de>
Uploaders: Fabio M. Di Nitto <fabbione@fabbione.net>
Build-Depends: ocaml (>= 3.08), camlp4, libdb-dev, debhelper (>= 7.0.50~), zlib1g-dev, libcryptokit-ocaml-dev (>= 1.2-4), ocaml-nox (>= 1.3-4), perl, perl-doc, dh-ocaml (>= 0.9~)

Package: sks
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${ocaml:Depends}, db-util, adduser, logrotate
Provides: ${ocaml:Provides}
Recommends: db4.7-util
Suggests: postfix | mail-transport-agent, procmail
Description: Synchronizing OpenPGP Key Server
 SKS is an OpenPGP key server that correctly handles all OpenPGP features
 defined in RFC2440 and RFC2440bis, including photoID packages and multiple
 subkeys.
 .
 This key server implementation uses an efficient and reliable reconciliation
 algorithm to keep the database in sync with other SKS servers.  Additionally
 it can both send and receive PKS style sync emails.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

TMP     =$(CURDIR)/debian/sks

OCAMLABI = $(shell ocamlc -version)
BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
all      = $(if $(BYTECODE),all.bc,all)
install  = $(if $(BYTECODE),install.bc,install)
OCAMLRUN = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))

export DEB_BUILD_OPTIONS += $(if $(BYTECODE)," nostrip",)

BDB_VERSION ?= $(shell LC_ALL=C dpkg-query -l 'libdb[45].[0-9]-dev' | grep ^.i | sed -e 's|.*\s\libdb\([45]\.[0-9]\)-dev\s.*|\1|')

%:
	dh  $@ --with=ocaml

override_dh_auto_build:
	dh_auto_build -v --  $(all)

override_dh_auto_install:
#	dh_auto_install -v -- PREFIX="$(TMP)/usr" MANDIR="$(TMP)/usr/share/man" $(install)
	$(MAKE) PREFIX="$(TMP)/usr" MANDIR="$(TMP)/usr/share/man" $(install)
#	Debian specific
	cp -a debian/debcfg/* debian/sks/etc/sks
	# Check that we have a value for BDB_VERSION
	[ -n "$(BDB_VERSION)" ]
	echo $(BDB_VERSION) > debian/sks/usr/lib/sks/berkeley_db.txt

# Use override_dh_* targets to customize this.
# ---------------------------------------------------
# Followings are the old debian/rules
#
# #!/usr/bin/make -f
# 
# TAR_DIR = sks-1.1.1
# # the dbs rules
# include /usr/share/dbs/dbs-build.mk
# 
# ifeq (,$(DEB_BUILD_GNU_TYPE))
#   include /usr/share/dbs/dpkg-arch.mk
# endif
# 
# TMP     =$(CURDIR)/debian/sks
# 
# OCAMLABI = $(shell ocamlc -version)
# BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
# all      = $(if $(BYTECODE),all.bc,all)
# install  = $(if $(BYTECODE),install.bc,install)
# OCAMLRUN = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))
# 
# DEBCFLAGS = -g
# ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
# 	DEBCFLAGS += -O0
# else
# 	DEBCFLAGS += -O3
# endif
# 
# debug:
# 	ls -l
# 
# configure: configure-stamp
# configure-stamp: $(patched)
# 	dh_testdir
# 	cd $(BUILD_TREE) && make clean dep
# 	touch configure-stamp
# 
# build: debug configure-stamp build-stamp
# build-stamp: $(patched)
# 	dh_testdir
# 	#cat /usr/lib/ocaml/*/native-archs
# 	cd $(BUILD_TREE) && $(MAKE) DEBCFLAGS="$(DEBCFLAGS)" $(all)
# 	touch build-stamp
# 
# install: build
# 	dh_testdir
# 	dh_testroot
# 	dh_clean -k
# 	dh_installdirs
# 	dh_installdocs
# 	dh_installchangelogs
# 
# 	# from upstream
# 	cd $(BUILD_TREE) && $(MAKE) PREFIX="$(TMP)/usr" MANDIR="$(TMP)/usr/share/man" $(install)
# 	#install -m 755 $(BUILD_TREE)/sks debian/sks/usr/sbin/sks
# 	#install -m 755 $(BUILD_TREE)/sks_add_mail debian/sks/usr/lib/sks/sks_add_mail
# 
# 	# Debian specific
# 	cp -a debian/debcfg/* debian/sks/etc/sks
# 
# binary-arch: install
# 	dh_testdir
# 	dh_testroot
# 	dh_compress
# 	dh_fixperms
# 	if [ -z $(BYTECODE) ]; then \
# 		dh_strip; \
# 	fi
# 	dh_shlibdeps
# 	dh_installdebconf
# 	dh_installlogrotate
# 	dh_installinit
# 	dh_installcron
# 	dh_installdeb
# 	dh_gencontrol -- -VF:OCamlRun="$(OCAMLRUN)"
# 	dh_md5sums
# 	dh_builddeb
# 
# binary-indep:
# 	# do nothing
# 
# binary: binary-arch binary-indep
# 
# clean:
# 	dh_testdir
# 	dh_testroot
# 	rm -f build-stamp configure-stamp
# 	rm -rf $(STAMP_DIR) $(SOURCE_DIR)
# 	dh_clean

## sks 1.1.3

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 
 CAMLP4=-pp $(CAMLP4O)
 CAMLINCLUDE= -I lib -I bdb
-COMMONCAMLFLAGS=$(CAMLINCLUDE) $(OCAMLLIB) -ccopt -Lbdb -dtypes -ccopt -pthread -warn-error A
+COMMONCAMLFLAGS=$(CAMLINCLUDE) $(OCAMLLIB) -ccopt -Lbdb -dtypes -ccopt -pthread -ccopt -pg -warn-error A
 OCAMLDEP=ocamldep $(CAMLP4) 
 CAMLLIBS=unix.cma str.cma bdb.cma nums.cma bigarray.cma cryptokit.cma
 OCAMLFLAGS=$(COMMONCAMLFLAGS) -g $(CAMLLIBS)
@@ -204,7 +204,7 @@
 	pMap.cmo pSet.cmo add_mail.cmo
 
 sks_add_mail: $(LIBS) pMap.cmx pSet.cmx add_mail.cmx
-	$(OCAMLOPT) -o sks_add_mail unix.cmxa \
+	$(OCAMLOPT) -o sks_add_mail -ccopt -pg unix.cmxa \
 	pMap.cmx pSet.cmx add_mail.cmx
 
 ocamldoc.out: $(ALLOBJS) $(EXEOBJS)
@@ -248,7 +248,7 @@
 	sks/.depend sks/*.tar.gz \
 	sks/bdb/Makefile sks/bdb/*.ml sks/bdb/*.mli sks/bdb/*.c \
 	sks/bdb/*.h sks/README sks/COPYING sks/VERSION sks/FILES \
-	sks/Makefile.local.unused sks/sks.8.gz
+	sks/Makefile.local.unused sks/sks.8
 
 ##################################
 # LIBS
@@ -398,10 +398,10 @@
 	rm -rf
 
 # Dependencies
+
 dep: 
 	$(OCAMLDEP) $(INCLUDES) *.ml *.mli > .depend
 
-include .depend
-
+-include .depend
 
 # DO NOT DELETE

=== debian/changelog ===
sks (1.1.3-1ubuntu2) quantal; urgency=low

  * Look for ^.i not ^ii in libdbX.Y-dev packages for BDB_VERSION. And assert
    that we have a value (LP: #1021650)

 -- Stefano Rivera <stefanor@ubuntu.com>  Fri, 06 Jul 2012 22:30:42 +0200

sks (1.1.3-1ubuntu1) quantal; urgency=low

  * Provide OLD_BDB versions for Ubuntu (LP: #1020034)
  * Create /var/lib/sks/berkeley_db.active even when we aren't upgrading BDB
    versions.
  * Include pagesize and ptree_pagesize in sksconf, so that importing a dump
    won't hang (LP: #1019756)

 -- Stefano Rivera <stefanor@ubuntu.com>  Mon, 02 Jul 2012 12:50:53 +0200

sks (1.1.3-1) unstable; urgency=low

  * New upstream release (closes: #663757)
  * change patches to work with new release
  * include sample config and web
  * include default index.html and robots.txt (closes: #600008)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Wed, 20 Jun 2012 11:58:47 +0200

sks (1.1.1+dpkgv3-8) unstable; urgency=low

  * fix debian/watch
  * drop recommends on db4.7-utils (closes: 664768) Hopyfully you have the
    db-utils from you old db version installed. But it should also work
    without that.
  * change default mailsync server (closes: 599919)
  * change init script to not background sks too early to see error
    messages (closes: 651843)
  * bump Standards-Version to 3.9.1 (no changes)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Fri, 11 May 2012 17:15:08 +0200

sks (1.1.1+dpkgv3-7.1) unstable; urgency=low

  * Non-Maintainer Upload.
  * emit proper HTTP 1.0 POSTs from recon process (Closes: #667695)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 06 Apr 2012 10:36:48 -0400

=== debian/rules ===
--- 
+++ 
@@ -18,6 +18,7 @@
 	dh  $@ --with=ocaml
 
 override_dh_auto_build:
+	make dep
 	dh_auto_build -v --  $(all)
 
 override_dh_auto_install:
@@ -28,6 +29,7 @@
 	# Check that we have a value for BDB_VERSION
 	[ -n "$(BDB_VERSION)" ]
 	echo $(BDB_VERSION) > debian/sks/usr/lib/sks/berkeley_db.txt
+	cp -a sampleWeb/OpenPKG/* debian/sks/var/lib/sks/www/
 
 # Use override_dh_* targets to customize this.
 # ---------------------------------------------------

=== debian/watch ===
version=3
opts=downloadurlmangle=s/\/\/code.google.com// http://code.google.com/p/sks-keyserver/downloads/list?can=1 .*/sks-(\d[\d.]*)\.(?:zip|tgz|tbz2|txz|tar\.gz|tar\.bz2|tar\.xz)

## sks 1.1.4

=== Makefile ===
--- 
+++ 
@@ -12,7 +12,7 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program; if not, write to the Free Software
 #   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
-#   USA 
+#   USA
 #
 CINCLUDES=-I`ocamlc -where`
 CC=gcc
@@ -39,26 +39,26 @@
 ifndef PREFIX
 	PREFIX=/usr/local
 endif
-ifeq ($(BDBLIB),) 
+ifeq ($(BDBLIB),)
 	OCAMLLIB=
-else 
+else
 	OCAMLLIB= -ccopt $(BDBLIB)
 endif
 
 CAMLP4=-pp $(CAMLP4O)
 CAMLINCLUDE= -I lib -I bdb
-COMMONCAMLFLAGS=$(CAMLINCLUDE) $(OCAMLLIB) -ccopt -Lbdb -dtypes -ccopt -pthread -ccopt -pg -warn-error A
-OCAMLDEP=ocamldep $(CAMLP4) 
+COMMONCAMLFLAGS=$(CAMLINCLUDE) $(OCAMLLIB) -ccopt -Lbdb -dtypes -warn-error A
+OCAMLDEP=ocamldep $(CAMLP4)
 CAMLLIBS=unix.cma str.cma bdb.cma nums.cma bigarray.cma cryptokit.cma
 OCAMLFLAGS=$(COMMONCAMLFLAGS) -g $(CAMLLIBS)
-OCAMLOPTFLAGS=$(COMMONCAMLFLAGS) -inline 40 $(CAMLLIBS:.cma=.cmxa) 
+OCAMLOPTFLAGS=$(COMMONCAMLFLAGS) -inline 40 $(CAMLLIBS:.cma=.cmxa)
 
 EXE=sks sks_add_mail
 ALL=$(EXE) sks.8.gz
 ALL.bc=$(EXE:=.bc) sks.8.gz
 
-all: $(ALL) 
-all.bc: $(ALL.bc) 
+all: $(ALL)
+all.bc: $(ALL.bc)
 
 COBJS=crc.o
 
@@ -75,7 +75,8 @@
 	fqueue.cmo prefixTree.cmo msgContainer.cmo \
 	nbMsgContainer.cmo cMarshal.cmo reconMessages.cmo \
 	server.cmo client.cmo reconCS.cmo \
-	number_test.cmo decode_test.cmo poly_test.cmo
+	number_test.cmo decode_test.cmo poly_test.cmo \
+	Unique_time.cmo version.cmo
 ROBJS=$(ROBJS.bc:.cmo=.cmx)
 
 OBJS.bc=packet.cmo parsePGP.cmo sStream.cmo bdbwrap.cmo \
@@ -122,15 +123,15 @@
 keyMerge.cmx: keyMerge.ml
 	$(OCAMLOPT) $(OCAMLOPTFLAGS) $(CAMLP4) -c $<
 
-# Special targets 
-
-install: 
+# Special targets
+
+install:
 	mkdir -p $(PREFIX)/bin
 	install sks_build.sh sks sks_add_mail $(PREFIX)/bin
 	mkdir -p $(MANDIR)/man8
 	install sks.8.gz $(MANDIR)/man8
 
-install.bc: 
+install.bc:
 	mkdir -p $(PREFIX)/bin
 	install sks_build.bc.sh sks.bc sks_add_mail.bc $(PREFIX)/bin
 	mkdir -p $(MANDIR)/man8
@@ -138,9 +139,9 @@
 
 
 Makefile.local:
-	touch Makefile.local
-
-src: 
+	@if [ ! -e Makefile.local ]; then echo "Makefile.local has to be defined before building. See Makefile.local.unused"; exit 1; fi;
+
+src:
 	if [ ! -x $(VERSIONPREFIX) ]; then ln -s . $(VERSIONPREFIX); fi
 	tar cfz $(VERSIONPREFIX).tgz $(FILES)
 	rm $(VERSIONPREFIX)
@@ -159,14 +160,20 @@
 spider.bc: $(LIBS.bc) $(ALLOBJS.bc) spider.cmo
 	$(OCAMLC) -o spider.bc $(OCAMLFLAGS) $(ALLOBJS.bc) spider.cmo
 
+sksclient: $(LIBS) $(ALLOBJS) sksclient.cmx
+	$(OCAMLOPT) -o sksclient $(OCAMLOPTFLAGS) $(ALLOBJS) sksclient.cmx
+
+sksclient.bc: $(LIBS.bc) $(ALLOBJS.bc) sksclient.cmo
+	$(OCAMLC) -o sksclient.bc $(OCAMLFLAGS) $(ALLOBJS.bc) sksclient.cmo
+
 sks: $(LIBS) $(ALLOBJS) sks.cmx
 	$(OCAMLOPT) -o sks $(OCAMLOPTFLAGS) $(ALLOBJS) sks.cmx
 
 sks.bc: $(LIBS.bc) $(ALLOBJS.bc) sks.cmo
 	$(OCAMLC) -o sks.bc $(OCAMLFLAGS) $(ALLOBJS.bc) sks.cmo
 
-nbtest.bc: $(LIBS.bc) $(ALLOBJS.bc) nbtest.cmo 
-	$(OCAMLC) -o nbtest.bc $(OCAMLFLAGS) $(ALLOBJS.bc) nbtest.cmo 
+nbtest.bc: $(LIBS.bc) $(ALLOBJS.bc) nbtest.cmo
+	$(OCAMLC) -o nbtest.bc $(OCAMLFLAGS) $(ALLOBJS.bc) nbtest.cmo
 
 ptest: $(LIBS) $(ALLOBJS) ptest.cmx
 	$(OCAMLOPT) -o ptest $(OCAMLOPTFLAGS) $(ALLOBJS) \
@@ -204,12 +211,12 @@
 	pMap.cmo pSet.cmo add_mail.cmo
 
 sks_add_mail: $(LIBS) pMap.cmx pSet.cmx add_mail.cmx
-	$(OCAMLOPT) -o sks_add_mail -ccopt -pg unix.cmxa \
+	$(OCAMLOPT) -o sks_add_mail unix.cmxa \
 	pMap.cmx pSet.cmx add_mail.cmx
 
 ocamldoc.out: $(ALLOBJS) $(EXEOBJS)
 	ocamldoc -hide Pervasives,UnixLabels,MoreLabels \
-	-dot $(CAMLP4O) -d doc -I lib -I bdb *.ml *.mli
+	-dot $(CAMLP4O) -d doc -I lib -I bdb *.mli *.ml
 
 sks_logdump.bc: $(LIBS.bc) $(ALLOBJS.bc) logdump.cmo
 	$(OCAMLC) -o sks_logdump.bc $(OCAMLFLAGS) $(ALLOBJS.bc) logdump.cmo
@@ -218,7 +225,7 @@
 	$(OCAMLOPT) -o sks_logdump $(OCAMLOPTFLAGS) $(ALLOBJS) \
 	logdump.cmx
 
-bugscript: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx bugscript.cmx 
+bugscript: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx bugscript.cmx
 	$(OCAMLOPT) -o bugscript $(OCAMLOPTFLAGS) $(ALLOBJS) \
 	reconPTreeDb.cmx bugscript.cmx
 
@@ -226,7 +233,7 @@
 	$(OCAMLC) -o bugscript.bc $(OCAMLFLAGS) $(ALLOBJS.bc) \
 	reconPTreeDb.cmo bugscript.cmo
 
-ptree_replay: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx ptree_replay.cmx 
+ptree_replay: $(LIBS) $(ALLOBJS) reconPTreeDb.cmx ptree_replay.cmx
 	$(OCAMLOPT) -o ptree_replay $(OCAMLOPTFLAGS) $(ALLOBJS) \
 	reconPTreeDb.cmx ptree_replay.cmx
 
@@ -239,15 +246,15 @@
 doc: $(ALLOBJS) $(EXEOBJS)
 	mkdir -p doc
 	ocamldoc -hide Pervasives,UnixLabels,MoreLabels \
-	-html $(CAMLP4O) -d doc -I lib -I bdb *.ml *.mli
+	-html $(CAMLP4O) -d doc -I lib -I bdb *.mli *.ml
 
 dist:
 	cd .. && \
 	tar cvfz sks.tgz \
-	sks/*.ml sks/*.mli sks/*.c sks/Makefile \
+	sks/*.mli sks/*.ml sks/*.c sks/Makefile \
 	sks/.depend sks/*.tar.gz \
-	sks/bdb/Makefile sks/bdb/*.ml sks/bdb/*.mli sks/bdb/*.c \
-	sks/bdb/*.h sks/README sks/COPYING sks/VERSION sks/FILES \
+	sks/bdb/Makefile sks/bdb/*.mli sks/bdb/*.ml sks/bdb/*.c \
+	sks/bdb/*.h sks/README.md sks/LICENSE sks/VERSION sks/FILES \
 	sks/Makefile.local.unused sks/sks.8
 
 ##################################
@@ -273,15 +280,16 @@
 	touch prepared
 
 
-CKDIR=cryptokit-1.0
-
-$(CKDIR)/README: 
-	tar xmvfz $(CKDIR).tar.gz
-
-$(CKDIR)/cryptokit.cma: $(CKDIR)/README
+CKVER=cryptokit-1.5
+CKDIR=$(CKVER)/src
+
+$(CKVER)/README.txt:
+	tar xmvfz $(CKVER).tar.gz
+
+$(CKDIR)/cryptokit.cma: $(CKVER)/README.txt
 	cd $(CKDIR) && $(MAKE) all
 
-$(CKDIR)/cryptokit.cmxa: $(CKDIR)/README
+$(CKDIR)/cryptokit.cmxa: $(CKVER)/README.txt
 	cd $(CKDIR) && $(MAKE) allopt
 
 lib/cryptokit.cma: $(CKDIR)/cryptokit.cma $(CKDIR)/cryptokit.cmxa prepared
@@ -318,16 +326,16 @@
 	$(ROBJS) pdiskTest.cmo
 
 script: $(LIBS) $(ALLOBJS) script.cmo
-	$(OCAMLC) -o script $(OCAMLFLAGS) $(ALLOBJS) script.cmo 
+	$(OCAMLC) -o script $(OCAMLFLAGS) $(ALLOBJS) script.cmo
 
 dbtest.bc: $(LIBS.bc) $(ALLOBJS.bc) dbtest.cmo
-	$(OCAMLC) -o dbtest.bc $(OCAMLFLAGS) $(ALLOBJS.bc) dbtest.cmo 
+	$(OCAMLC) -o dbtest.bc $(OCAMLFLAGS) $(ALLOBJS.bc) dbtest.cmo
 
 dbtest: $(LIBS) $(ALLOBJS) dbtest.cmx
 	$(OCAMLOPT) -o dbtest $(OCAMLOPTFLAGS) $(ALLOBJS) dbtest.cmx
 
 tester: $(LIBS) $(ALLOBJS) tester.cmo
-	$(OCAMLC) -o tester $(OCAMLFLAGS) $(ALLOBJS) tester.cmo 
+	$(OCAMLC) -o tester $(OCAMLFLAGS) $(ALLOBJS) tester.cmo
 
 dumbloop: $(LIBS) $(ALLOBJS) dumbloop.cmo
 	$(OCAMLC) -o dumbloop $(OCAMLFLAGS) $(ALLOBJS) dumbloop.cmo
@@ -347,26 +355,26 @@
 krecode: $(ALLOBJS.opt) $(LIBS) recode.ml
 	$(OCAMLOPT) -o krecode $(OCAMLOPTFLAGS) $(ALLOBJS.opt) recode.ml
 
-rcaml: $(LIBS.bc) $(ALLOBJS.bc) 
+rcaml: $(LIBS.bc) $(ALLOBJS.bc)
 	ocamlmktop -o rcaml -custom $(CAMLLIBS) $(CAMLINCLUDE) \
 	$(ALLOBJS.bc) $(OCAMLLIB)
 
 
 
 # Common rules
-.SUFFIXES: .ml .mli .cmo .cmi .cmx
+.SUFFIXES: .mli .ml .cmo .cmi .cmx
 
 .ml.o:
-	$(OCAMLOPT) -output-obj $(OCAMLOPTFLAGS) $< 
+	$(OCAMLOPT) -output-obj $(OCAMLOPTFLAGS) $<
 
 .cpp.o:
 	$(CXX) $(CXXFLAGS) -c $<
 
 .c.o:
-	$(CC) $(CFLAGS) -c $< 
+	$(CC) $(CFLAGS) -c $<
 
 .c.obj:
-	$(CC) $(CFLAGS) /c $< 
+	$(CC) $(CFLAGS) /c $<
 
 .ml.cmo:
 	$(OCAMLC) $(OCAMLFLAGS) -c $<
@@ -384,6 +392,7 @@
 	rm -f *.annot
 	rm -f *.opt
 	rm -f *.bc
+	rm -rf spider sksclient
 	rm -f $(ALL) $(ALL.bc)
 
 clean: mlclean
@@ -393,14 +402,16 @@
 
 cleanall: clean bdbclean
 	rm -f lib/*
-	rm -rf $(CKDIR)
-	rm -rf $(NXDIR)
-	rm -rf
+	rm -rf $(CKVER)
+
+distclean: cleanall
+	rm -rf Makefile.local
+	rm -rf .depend tmp lib
 
 # Dependencies
 
-dep: 
-	$(OCAMLDEP) $(INCLUDES) *.ml *.mli > .depend
+dep:
+	$(OCAMLDEP) $(INCLUDES) *.mli *.ml > .depend
 
 -include .depend

=== src/Makefile ===
### Configuration section

# Comment next line if the Zlib library is not available
ZLIB=-DHAVE_ZLIB

# The name of the Zlib library.  Usually -lz.  
# Leave blank if you don't have Zlib.
ZLIB_LIB=-lz

# The directory containing the Zlib library (libz.a or libz.so)
# Leave blank if you don't have Zlib.
ZLIB_LIBDIR=/usr/lib
#ZLIB_LIBDIR=/usr/lib64    # for x86-64 Linux

# The directory containing the Zlib header file (zlib.h)
ZLIB_INCLUDE=/usr/include

# Where to install the library. By default: OCaml's standard library directory.
INSTALLDIR=`$(OCAMLC) -where`

# Flags for the C compiler.
CFLAGS=-O -I$(ZLIB_INCLUDE) $(ZLIB)

### End of configuration section

OCAMLRUN=ocamlrun
OCAMLC=ocamlc -g
OCAMLOPT=ocamlopt
OCAMLDEP=ocamldep
MKLIB=ocamlmklib
OCAMLDOC=ocamldoc

C_OBJS=\
  rijndael-alg-fst.o stubs-aes.o \
  d3des.o stubs-des.o \
  arcfour.o stubs-arcfour.o \
  sha1.o stubs-sha1.o \
  sha256.o stubs-sha256.o \
  ripemd160.o stubs-ripemd160.o \
  blowfish.o stubs-blowfish.o \
  stubs-md5.o \
  stubs-zlib.o \
  stubs-misc.o \
  stubs-rng.o

CAML_OBJS=cryptokit.cmo

all: libcryptokit.a cryptokit.cmi cryptokit.cma 

allopt: libcryptokit.a cryptokit.cmi cryptokit.cmxa 

libcryptokit.a: $(C_OBJS)
	$(MKLIB) -o cryptokit $(C_OBJS) -L$(ZLIB_LIBDIR) $(ZLIB_LIB)

cryptokit.cma: $(CAML_OBJS)
	$(MKLIB) -o cryptokit $(CAML_OBJS) -L$(ZLIB_LIBDIR) $(ZLIB_LIB)

cryptokit.cmxa: $(CAML_OBJS:.cmo=.cmx)
	$(MKLIB) -o cryptokit $(CAML_OBJS:.cmo=.cmx) -L$(ZLIB_LIBDIR) $(ZLIB_LIB)

test: test.byt
	$(OCAMLRUN) -I . ./test.byt

test.byt: libcryptokit.a cryptokit.cma test.ml
	$(OCAMLC) -o test.byt unix.cma nums.cma cryptokit.cma test.ml

clean::
	rm -f test.byt

speedtest: libcryptokit.a cryptokit.cmxa speedtest.ml
	$(OCAMLOPT) -o speedtest -ccopt -L. \
                unix.cmxa nums.cmxa cryptokit.cmxa speedtest.ml

clean::
	rm -f speedtest

install:
	cp cryptokit.cmi cryptokit.cma cryptokit.mli $(INSTALLDIR)
	cp libcryptokit.a $(INSTALLDIR)
	if test -f dllcryptokit.so; then cp dllcryptokit.so $(INSTALLDIR)/stublibs; fi
	if test -f cryptokit.cmxa; then cp cryptokit.cmxa cryptokit.cmx cryptokit.a $(INSTALLDIR); fi

doc: FORCE
	cd doc; $(OCAMLDOC) -html -I .. ../cryptokit.mli

FORCE:

.SUFFIXES: .ml .mli .cmo .cmi .cmx

.mli.cmi:
	$(OCAMLC) -c $(COMPFLAGS) $<

.ml.cmo:
	$(OCAMLC) -c $(COMPFLAGS) $<

.ml.cmx:
	$(OCAMLOPT) -c $(COMPFLAGS) $<

.c.o:
	$(OCAMLC) -c -ccopt "$(CFLAGS)" $<

clean::
	rm -f *.cm* *.o *.a *.so

depend:
	gcc -MM -I `$(OCAMLC) -where` -isystem `$(OCAMLC) -where ` *.c > .depend
	$(OCAMLDEP) *.mli *.ml >> .depend

include .depend

=== debian/changelog ===
sks (1.1.4-2.1ubuntu1) trusty; urgency=medium

  * Merge with Debian; remaining changes:
    - debian/sks.postinst: Provide OLD_BDB versions for Ubuntu.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 23:03:20 +0000

sks (1.1.4-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Fix compilation with OCaml 4.01.0 (Closes: #731584)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 10 Dec 2013 07:18:02 +0100

sks (1.1.4-2ubuntu2) trusty; urgency=medium

  * Rebuild for ocaml-4.01.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Dec 2013 20:28:21 +0000

sks (1.1.4-2ubuntu1) trusty; urgency=low

  * Merge from Debian unstable. (LP: #1247908, #1096116)
    Remaining changes:
    - debian/sks.postinst: Provide OLD_BDB versions for Ubuntu.
  * Dropped change, already applied in Debian:
    - Look for ^.i not ^ii in libdbX.Y-dev packages for
      BDB_VERSION and assert that we have a value.

 -- Artur Rona <ari-tczew@tlen.pl>  Mon, 04 Nov 2013 17:50:37 +0100

sks (1.1.4-2) unstable; urgency=low

  * move to unstable
  * 1.1.4 stops creating gmon.out (Closes: #699847)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 01 Aug 2013 23:04:12 -0400

sks (1.1.4-1) experimental; urgency=low

  * New Upstream Release (Closes: #690135)
  * added myself to Uploaders.
  * convert to dh 9
  * Standards-Version: bump to 3.9.4 (no changes needed)
  * debian/rules: clean up
  * refresh and clean up debian/patches
  * switch packaging vcs to git
  * avoid trying to upgrade DB_CONFIG (Closes: #709322)
  
 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 27 Jun 2013 16:39:02 -0400

sks (1.1.3-3) UNRELEASED; urgency=low

  [ Christoph Martin ]
  * merge Ubuntu changes
  * Look for ^.i not ^ii in libdbX.Y-dev packages for BDB_VERSION. And
    assert that we have a value (LP: #1021650)
  * Create /var/lib/sks/berkeley_db.active even when we aren't upgrading BDB
    versions.

  [ Daniel Kahn Gillmor ]
  * avoid trying to upgrade DB_CONFIG (Closes: #709322)
  * switch to git
  * adding myself to uploaders
  * use debhelper 9

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 28 Jun 2013 18:10:07 -0400

sks (1.1.3-2ubuntu2) trusty; urgency=low

  * No change rebuild against db 5.3.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Sat, 02 Nov 2013 19:08:26 +0000

sks (1.1.3-2ubuntu1) raring; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/rules: Look for ^.i not ^ii in libdbX.Y-dev packages for
      BDB_VERSION and assert that we have a value.
    - debian/sks.postinst: Provide OLD_BDB versions for Ubuntu.
  * Dropped changes:
    - Include pagesize and ptree_pagesize in sksconf so that importing a dump
      won't hang (a similar change was made in Debian).

 -- Logan Rosen <logan@ubuntu.com>  Sun, 24 Mar 2013 01:21:06 -0400

sks (1.1.3-2) unstable; urgency=high

  * add Vcs tags to control file
  * fix watch file because of upstream move
  * add Homepage tag to control file
  * add db parameter to sksconf to fix db build deadlocks (closes: #699848)

 -- Christoph Martin <christoph.martin@uni-mainz.de>  Mon, 11 Mar 2013 16:48:16 +0100

sks (1.1.3-1ubuntu3) quantal; urgency=low

  * debian/sks.postinst: LP: #1061769
    - detect if Ubuntu system, even if dpkg-vendor is not available

 -- Dustin Kirkland <kirkland@ubuntu.com>  Thu, 04 Oct 2012 12:44:23 -0500

=== debian/rules ===
#!/usr/bin/make -f
TMP     =$(CURDIR)/debian/sks

OCAMLABI = $(shell ocamlc -version)
BYTECODE = $(shell [ -x /usr/bin/ocamlopt ] || echo yes)
all      = $(if $(BYTECODE),all.bc,all)
install  = $(if $(BYTECODE),install.bc,install)
OCAMLRUN = $(if $(BYTECODE),ocaml-base-nox-$(OCAMLABI))

export DEB_BUILD_OPTIONS += $(if $(BYTECODE)," nostrip",)

BDB_VERSION ?= $(shell LC_ALL=C dpkg-query -l 'libdb[45].[0-9]-dev' | grep ^.i | sed -e 's|.*\s\libdb\([45]\.[0-9]\)-dev\s.*|\1|')

%:
	dh  $@ --with=ocaml

override_dh_auto_clean:
	touch Makefile.local
	dh_auto_clean
	touch .depend

override_dh_auto_build:
	touch Makefile.local
	make dep
	dh_auto_build -v --  $(all)

override_dh_auto_install:
#	dh_auto_install -v -- PREFIX="$(TMP)/usr" MANDIR="$(TMP)/usr/share/man" $(install)
	$(MAKE) PREFIX="$(TMP)/usr" MANDIR="$(TMP)/usr/share/man" $(install)
#	Debian specific
	cp -a debian/debcfg/* debian/sks/etc/sks
#	Check that we have a value for BDB_VERSION
	[ -n "$(BDB_VERSION)" ]
	echo $(BDB_VERSION) > debian/sks/usr/lib/sks/berkeley_db.txt
	cp -a sampleWeb/OpenPKG/* debian/sks/var/lib/sks/www/
